/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2007
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.10 [6 Mar. 2007]
**
**  Device :	uPD78F0533_64
**
**  Compiler :	CC78K0
**
**  Creation date:	2007/07/17
**  
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "System.h"
#include "Port.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
unsigned long	sokutei_hz;
unsigned char	s_mode;
unsigned char	s_sub;
unsigned char	sub_455;

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	P2.0=data&0x01;
	P2.1=(data&0x02)>>1;
	P2.2=(data&0x04)>>2;
	P2.3=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	P14.1=0;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_d_set(void)
{
	P14.1=1;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(300);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(300);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_hz_sub10(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;
unsigned char f;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	lcd_print(" ");
	if(n5==0){lcd_print(" ");f=0;}else{lcd_su(n5);f=1;}
	if((n4==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n4);f=1;}
	if((n3==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n3);f=1;}
	if((n2==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n2);f=1;}
	if((n1==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n1);}
	lcd_su(n0);
	lcd_print(" Hz");
}
void	lcd_hz_sub11(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;
unsigned char f;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	if(n5==0){lcd_print(" ");f=0;}else{lcd_su(n5);f=1;}
	if((n4==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n4);f=1;}
	lcd_su(n3);
	lcd_print(".");
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
	lcd_print("kHz");
}

void	lcd_hz_sub20(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;
unsigned char f;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	if(n5==0){lcd_print(" ");f=0;}else{lcd_su(n5);f=1;}
	if((n4==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n4);f=1;}
	if((n3==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n3);f=1;}
	lcd_su(n2);
	lcd_print(".");
	lcd_su(n1);
	lcd_su(n0);
	lcd_print("kHz");
}
void	lcd_hz_sub21(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;
unsigned char f;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	lcd_su(n5);
	lcd_print(".");
	lcd_su(n4);
	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
	lcd_print("MHz");
}

void	lcd_hz_sub30(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	if(n5==0){lcd_print(" ");}else{lcd_su(n5);}
	lcd_su(n4);
	lcd_print(".");
	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
	lcd_print("MHz");
}
void	lcd_hz_sub31(unsigned long hz)
{
unsigned char n0,n1,n2,n3,n4,n5;
unsigned long count;
unsigned char f;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);count=(count-n4)/10;
	n5=(unsigned char)(count%10);

	if(n5==0){lcd_print(" ");f=0;}else{lcd_su(n5);f=1;}
	if((n4==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n4);f=1;}
	if((n3==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n3);f=1;}
	if((n2==0)&&(f==0)){lcd_print(" ");}else{lcd_su(n2);f=1;}
	lcd_su(n1);
	lcd_print(".");
	lcd_su(n0);
	lcd_print("kHz");
}

void	lcd_hz_main(unsigned long hz)
{
	switch(s_mode*2+s_sub){
		case 0:lcd_hz_sub10(hz);break;
		case 1:lcd_hz_sub11(hz);break;
		case 2:lcd_hz_sub20(hz);break;
		case 3:lcd_hz_sub21(hz);break;
		case 4:lcd_hz_sub30(hz);break;
		case 5:lcd_hz_sub31(hz);break;
	}
}
void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	lcd_xy(0,0);
	lcd_print("FREQ.COUNTER");
}

void	lcd_pr_sub(unsigned char no)
{
unsigned char n0,n1;
unsigned char count;

	count=no;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	lcd_su(n1);
	lcd_su(n0);
}
void	mode_disp(void)
{
	lcd_xy(12,1);
	switch(s_mode){
		case 0:lcd_print("  1s");break;
		case 1:lcd_print("100m");break;
		case 2:lcd_print(" 10m");break;
	}
}
void	s455_disp(void)
{
	lcd_xy(12,0);
	switch(sub_455){
		case 0:lcd_print("    ");break;
		case 1:lcd_print("-455");break;
		case 2:lcd_print("+455");break;
	}
}	
void	mode_set(void)
{
	switch(s_mode){
		case 0:P0.0=0;P0.1=0;P0.2=1;break;
		case 1:P0.0=0;P0.1=1;P0.2=0;break;
		case 2:P0.0=1;P0.1=0;P0.2=0;break;
	}
}
/*----------- DATA INPUT ----------*/
unsigned long freq_count_in(void)
{
unsigned long freq1,freq2;
unsigned long d0,d1,d2,d3,d4,d5;
unsigned char port7,port3,port4,port5,port6;

	port7=P7;port3=P3;port4=P4;port5=P5;port6=P6;
	
	d0=port7 & 0x0f;
	d1=(port7 & 0xf0)>>4;
	d2=port3 & 0x0f;
	d3=port4 & 0x0f;
	d4=port5 & 0x0f;
	d5=port6 & 0x0f;
	
	freq1=d0+d1*10+d2*100+d3*1000+d4*10000+d5*100000;

	port7=P7;port3=P3;port4=P4;port5=P5;port6=P6;
	
	d0=port7 & 0x0f;
	d1=(port7 & 0xf0)>>4;
	d2=port3 & 0x0f;
	d3=port4 & 0x0f;
	d4=port5 & 0x0f;
	d5=port6 & 0x0f;
	
	freq2=d0+d1*10+d2*100+d3*1000+d4*10000+d5*100000;

	freq1=(freq1+freq2)/2;

	switch(s_mode){
		case 0:switch(sub_455){
				case 1:freq1=freq1-455000;break;
				case 2:freq1=freq1+455000;break;
				}
				break;
		case 1:switch(sub_455){
				case 1:freq1=freq1-45500;break;
				case 2:freq1=freq1+45500;break;
				}
				break;
		case 2:switch(sub_455){
				case 1:freq1=freq1-4550;break;
				case 2:freq1=freq1+4550;break;
				}
				break;
	}

	return freq1;
}


/*---------- MAIN -----------*/
void  main( void )
{
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned int	sub;


	lcd_init();
	lcd_clear();

	lcd_ini_disp();
	sub=0;
	s_mode=0;
	s_sub=0;
	sub_455=0;
	
	mode_disp();
	s455_disp();
	mode_set();

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if (P1.1==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if (P1.2==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if (P1.3==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/


		
		/*--*/
		

		if(sub==0){
			sokutei_hz=freq_count_in();
			lcd_xy(0,1);
			lcd_hz_main(sokutei_hz);
			sub=20;
		}
		else{
			sub--;
		}

		if(P1.7==1){
				s_mode++;
				if(s_mode>=3){
					s_mode=2;
				}
			sub=0;
			s_sub=0;
			sub_455=0;
			mode_disp();
			s455_disp();
			mode_set();
		}


	/* key scan 2 */
		if ((P1.0==0)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if ((P1.1==0)&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if ((P1.2==0)&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if ((P1.3==0)&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/


	/* key action */
	
		if((sw1_key==0)&(sw1_rep==0)){
			sw1_rep=1;
			s_mode++;
			if(s_mode>=3){s_mode=0;}
			s_sub=0;
			sub_455=0;
			mode_disp();
			s455_disp();
			mode_set();
			sub=0;

		}
		/*------------------*/
		if((sw2_key==0)&(sw2_rep==0)){
			sw2_rep=1;
			s_sub++;
			if(s_sub>=2){s_sub=0;}
			sub_455=0;
			mode_disp();
			s455_disp();
			sub=0;
		}
		/*------------------*/
		if((sw3_key==0)&(sw3_rep==0)){
			sw3_rep=1;





		}
		/*--------------------*/
		if((sw4_key==0)&(sw4_rep==0)){
			sw4_rep=1;
			sub_455++;
			if(sub_455>=3){sub_455=0;}
			s455_disp();
			mode_disp();
			sub=0;
		}

		/*------------------*/

	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */

